/*
Testprogramm für den Slave 
Der Buffer wird mit Werten gefüllt. Dann wird er fortlaufend über die serielle Schnittstelle ausgegeben.
Nun kann man dort sehen, wenn der Master einen Wert ändert
*/
#include <util/twi.h>       //enthält z.B. die Bezeichnungen für die Statuscodes in TWSR
#include <avr/interrupt.h>  //dient zur Behandlung der Interrupts
#include <stdint.h>       //definiert den Datentyp uint8_t
#include "twislave.h"
#include <stdlib.h>         //nötig für Zahlumwandlung mit itoa
#include <util/delay.h>


#define SLAVE_ADRESSE 0x50 //Die Slave-Adresse


int main (void)
{

  DDRB = 0xFF;
	PORTB = 0x00;
	

  //TWI als Slave mit Adresse slaveadr starten
  init_twi_slave(SLAVE_ADRESSE);

  //i2cdata mit Werten füllen, die der Master auslesen und ändern kann
  for(uint8_t i=0;i<i2c_buffer_size;i++)
  {
    i2cdata[i]=10+i;
  }

  while(1) {
    if (i2cdata[0] == 'H') {
	    PORTB = 0x03;
    }
  }

} //end.main
