//  STM32 Discovery I2C Sample


#include "stm32f10x.h"
#include "i2c.h"

#define STACK_TOP 0x20002000-4										// init Stackpointer

void nmi_handler(void);												
void hardfault_handler(void);
    
unsigned char temp = 0;
unsigned char temp2 = 0;



int main(void);

/* vector table */

unsigned int * myvectors[4] 
__attribute__ ((section("vectors")))= {
    (unsigned int *)	STACK_TOP,         
    (unsigned int *) 	main,              
    (unsigned int *)	nmi_handler,       
    (unsigned int *)	hardfault_handler,

};

int main(void){	

  int SLAVE_ADDR = 0x50;

  /* Enable the GPIOA (bit 2) and GPIOC (bit 8) */
  RCC->APB2ENR |= 0x10 | 0x04;

  /* Set GPIOC Pin 8 and Pin 9 to outputs */
  GPIOC->CRH = 0x11;

  /* Set GPIOA Pin 0 to input floating */
  GPIOA->CRL = 0x04;
  
  /*
  GPIOC->BSRR = 1<<8;   //Switch on blue
  GPIOC->BSRR = 1<<24;  //Switch off blue
  GPIOC->BSRR = 1<<9 ;  //Switch green on
  GPIOC->BSRR = 1<<25;  //Switch green off
  */

  char buf[20];
  int off = 0;
  int len = 1;
  buf[0] = 'H';
  buf[1] = 'a';
  buf[2] = 'l';


  InitI2C();
  I2C_start(I2C1, SLAVE_ADDR << 1, I2C_Direction_Transmitter);

  I2C_write(I2C1, 0x00);    //Set internal Slave register
  I2C_write(I2C1, buf[0]);
  I2C_write(I2C1, buf[1]);
  I2C_write(I2C1, buf[2]);
  
  I2C_stop(I2C1);


  buf[0] = 0;
  buf[1] = 0;
  buf[2] = 0;


  I2C_start(I2C1, SLAVE_ADDR << 1 , I2C_Direction_Transmitter);
  I2C_write(I2C1, 0x00);
  I2C_restart(I2C1, SLAVE_ADDR << 1 , I2C_Direction_Receiver);
  buf[0] = I2C_read_ack(I2C1);
  buf[1] = I2C_read_ack(I2C1);
  buf[2] = I2C_read_nack(I2C1);
 
  I2C_stop(I2C1);


  if (buf[0] == 'H') {
    //Yipieea it works!

    GPIOC->BSRR = 1<<9 ;  //Switch green on
    GPIOC->BSRR = 1<<24;  //Switch off blue
  } else {
    GPIOC->BSRR = 1<<8;   //Switch on blue
    GPIOC->BSRR = 1<<25;  //Switch off green
  }

  while(1) ;


  return 0;
}

void nmi_handler(void)
{
    return ;
}

void hardfault_handler(void)
{
    return ;
}

